/* Tabela MAPAAPURAC: Cadastro de Mapa de Apurao */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela MAPAAPURAC */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Mapa de Apurao,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIS_MAPAAPURAC
AFTER DELETE OR INSERT OR UPDATE
ON MAPAAPURAC FOR EACH ROW
DECLARE
   V_DSREMOTEADDR VARCHAR2(50);
   V_DSREMOTEHOST VARCHAR2(50);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(50);
   V_DSREMOTEOPER VARCHAR2(12);
   V_NMOPERADOR   VARCHAR2(100);
   V_TIPO         VARCHAR2(1);
   V_DESC         VARCHAR2(1000);
   V_CDFILLOGOPER VARCHAR2(4);
   V_ITPESQ       VARCHAR2(40);
   V_DTOPER       DATE;
   V_STATUS       VARCHAR2(10);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN
      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || 'Empresa=' || :OLD.CDEMPRESA;
      END IF;
      IF :OLD.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || ' InscEstad=' || :OLD.CDINSCESTA;
      END IF;
      IF :OLD.CDINSCMUNI IS NOT NULL THEN
         V_DESC := V_DESC || ' InscMunicip=' || :OLD.CDINSCMUNI;
      END IF;
      IF :OLD.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' Imposto=' || :OLD.CDIMPOSTO;
      END IF;
      IF :OLD.IDBLOQMAPAPU IS NOT NULL THEN
         IF :OLD.IDBLOQMAPAPU = 'S' THEN
            V_STATUS := 'Bloqueado';
         ELSE
            V_STATUS := 'Aberto';
         END IF;
         V_DESC := V_DESC || ' Status=' || V_STATUS;
      END IF;
      IF :OLD.DTINIPERIODO IS NOT NULL THEN
         V_DESC := V_DESC || ' DataInicial=' || :OLD.DTINIPERIODO;
      END IF;
      IF :OLD.DTFIMPERIODO IS NOT NULL THEN
         V_DESC := V_DESC || ' DataFinal=' || :OLD.DTFIMPERIODO;
      END IF;
      IF :OLD.NMMAPAAPUR IS NOT NULL THEN
         V_DESC := V_DESC || ' NomeMapa=' || :OLD.NMMAPAAPUR;
      END IF;
      IF :OLD.VRTTCTBLCRE IS NOT NULL THEN
         V_DESC := V_DESC || ' VrContEntr=' || :OLD.VRTTCTBLCRE;
      END IF;
      IF :OLD.VRTTBACALCRE IS NOT NULL THEN
         V_DESC := V_DESC || ' VrBaseEntr=' || :OLD.VRTTBACALCRE;
      END IF;
      IF :OLD.VRTTCTBLDEB IS NOT NULL THEN
         V_DESC := V_DESC || ' VrContSaid=' || :OLD.VRTTCTBLDEB;
      END IF;
      IF :OLD.VRTTBACALDEB IS NOT NULL THEN
         V_DESC := V_DESC || ' VrBaseSaid=' || :OLD.VRTTBACALDEB;
      END IF;
      IF :OLD.VRTOTAIMPOS IS NOT NULL THEN
         V_DESC := V_DESC || ' VrImpostoRec=' || :OLD.VRTOTAIMPOS;
      END IF;
      IF :OLD.DTVENCGUIA IS NOT NULL THEN
         V_DESC := V_DESC || ' DataVenc=' || :OLD.DTVENCGUIA;
      END IF;
      IF :OLD.CDRECEGUIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CodReceita=' || :OLD.CDRECEGUIA;
      END IF;
      IF :OLD.DSHISTGUIA IS NOT NULL THEN
         V_DESC := V_DESC || ' Historico=' || :OLD.DSHISTGUIA;
      END IF;
      IF :OLD.VRRECEGUIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrReceita=' || :OLD.VRRECEGUIA;
      END IF;
      IF :OLD.VRJUROGUIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrJuro=' || :OLD.VRJUROGUIA;
      END IF;
      IF :OLD.VRMULTAGUIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrMulta=' || :OLD.VRMULTAGUIA;
      END IF;
      IF :OLD.VRTOTAGUIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrTotal=' || :OLD.VRTOTAGUIA;
      END IF;
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFilialNf=' || :OLD.CDFILIAL;
      END IF;
      IF :OLD.NRLANCTONF IS NOT NULL THEN
         V_DESC := V_DESC || ' NrLancamento=' || :OLD.NRLANCTONF;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.NRSEQUMAPAPU;
   ELSE
      IF UPDATING THEN
         IF NVL(:NEW.CDEMPRESA, '!')    <> NVL(:OLD.CDEMPRESA, '!')    OR
            NVL(:NEW.CDINSCESTA, '!')   <> NVL(:OLD.CDINSCESTA, '!')   OR
            NVL(:NEW.CDINSCMUNI, '!')   <> NVL(:OLD.CDINSCMUNI, '!')   OR
            NVL(:NEW.CDIMPOSTO, '!')    <> NVL(:OLD.CDIMPOSTO, '!')    OR
            NVL(:NEW.IDBLOQMAPAPU, '!') <> NVL(:OLD.IDBLOQMAPAPU, '!') OR
            NVL(:NEW.DTINIPERIODO,TO_DATE('01/01/1900', 'DD/MM/YYYY')) <> NVL(:OLD.DTINIPERIODO,TO_DATE('01/01/1900', 'DD/MM/YYYY')) OR
            NVL(:NEW.DTFIMPERIODO,TO_DATE('01/01/1900', 'DD/MM/YYYY')) <> NVL(:OLD.DTFIMPERIODO,TO_DATE('01/01/1900', 'DD/MM/YYYY')) OR
            NVL(:NEW.NMMAPAAPUR, '!')   <> NVL(:OLD.NMMAPAAPUR, '!')   OR
            NVL(:NEW.VRTTCTBLCRE, 0)    <> NVL(:OLD.VRTTCTBLCRE, 0)    OR
            NVL(:NEW.VRTTBACALCRE, 0)   <> NVL(:OLD.VRTTBACALCRE, 0)   OR
            NVL(:NEW.VRTTCTBLDEB, 0)    <> NVL(:OLD.VRTTCTBLDEB, 0)    OR
            NVL(:NEW.VRTTBACALDEB, 0)   <> NVL(:OLD.VRTTBACALDEB, 0)   OR
            NVL(:NEW.VRTOTAIMPOS, 0)    <> NVL(:OLD.VRTOTAIMPOS, 0)    OR
            NVL(:NEW.DTVENCGUIA,TO_DATE('01/01/1900', 'DD/MM/YYYY'))   <> NVL(:OLD.DTVENCGUIA,TO_DATE('01/01/1900', 'DD/MM/YYYY'))   OR
            NVL(:NEW.CDRECEGUIA, '!')   <> NVL(:OLD.CDRECEGUIA, '!')   OR
            NVL(:NEW.DSHISTGUIA, '!')   <> NVL(:OLD.DSHISTGUIA, '!')   OR
            NVL(:NEW.VRRECEGUIA, 0)     <> NVL(:OLD.VRRECEGUIA, 0)     OR
            NVL(:NEW.VRJUROGUIA, 0)     <> NVL(:OLD.VRJUROGUIA, 0)     OR
            NVL(:NEW.VRMULTAGUIA, 0)    <> NVL(:OLD.VRMULTAGUIA, 0)    OR
            NVL(:NEW.VRTOTAGUIA, 0)     <> NVL(:OLD.VRTOTAGUIA, 0)     OR
            NVL(:NEW.CDFILIAL, '!')     <> NVL(:OLD.CDFILIAL, '!')     OR
            NVL(:NEW.NRLANCTONF, '!')   <> NVL(:OLD.NRLANCTONF, '!')   THEN
            V_TIPO         := '2';
            V_ITPESQ       := :OLD.NRSEQUMAPAPU;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.NRSEQUMAPAPU;
      END IF;

      IF NVL(:NEW.CDEMPRESA, '!') <> NVL(:OLD.CDEMPRESA, '!') THEN
         V_DESC := V_DESC || 'Empresa=' || :NEW.CDEMPRESA;
      END IF;
      IF NVL(:NEW.CDINSCESTA, '!') <> NVL(:OLD.CDINSCESTA, '!') THEN
         V_DESC := V_DESC || ' InscEstad=' || :NEW.CDINSCESTA;
      END IF;
      IF NVL(:NEW.CDINSCMUNI, '!') <> NVL(:OLD.CDINSCMUNI, '!') THEN
         V_DESC := V_DESC || ' InscMunicip=' || :NEW.CDINSCMUNI;
      END IF;
      IF NVL(:NEW.CDIMPOSTO, '!') <> NVL(:OLD.CDIMPOSTO, '!') THEN
         V_DESC := V_DESC || ' Imposto=' || :NEW.CDIMPOSTO;
      END IF;
      IF NVL(:NEW.IDBLOQMAPAPU, '!') <> NVL(:OLD.IDBLOQMAPAPU, '!') THEN
         IF :NEW.IDBLOQMAPAPU = 'S' THEN
            V_STATUS := 'Bloqueado';
         ELSE
            V_STATUS := 'Aberto';
         END IF;
         V_DESC := V_DESC || ' Status=' || V_STATUS;
      END IF;
      IF NVL(:NEW.DTINIPERIODO,TO_DATE('01/01/1900', 'DD/MM/YYYY')) <> NVL(:OLD.DTINIPERIODO,TO_DATE('01/01/1900', 'DD/MM/YYYY')) THEN
         V_DESC := V_DESC || ' DataInicial=' || :NEW.DTINIPERIODO;
      END IF;
      IF NVL(:NEW.DTFIMPERIODO,TO_DATE('01/01/1900', 'DD/MM/YYYY')) <> NVL(:OLD.DTFIMPERIODO,TO_DATE('01/01/1900', 'DD/MM/YYYY')) THEN
         V_DESC := V_DESC || ' DataFinal=' || :NEW.DTFIMPERIODO;
      END IF;
      IF NVL(:NEW.NMMAPAAPUR, '!') <> NVL(:OLD.NMMAPAAPUR, '!') THEN
         V_DESC := V_DESC || ' NomeMapa=' || :NEW.NMMAPAAPUR;
      END IF;
      IF NVL(:NEW.VRTTCTBLCRE, 0) <> NVL(:OLD.VRTTCTBLCRE, 0) THEN
         V_DESC := V_DESC || ' VrContEntr=' || :NEW.VRTTCTBLCRE;
      END IF;
      IF NVL(:NEW.VRTTBACALCRE, 0) <> NVL(:OLD.VRTTBACALCRE, 0) THEN
         V_DESC := V_DESC || ' VrBaseEntr=' || :NEW.VRTTBACALCRE;
      END IF;
      IF NVL(:NEW.VRTTCTBLDEB, 0) <> NVL(:OLD.VRTTCTBLDEB, 0) THEN
         V_DESC := V_DESC || ' VrContSaid=' || :NEW.VRTTCTBLDEB;
      END IF;
      IF NVL(:NEW.VRTTBACALDEB, 0) <> NVL(:OLD.VRTTBACALDEB, 0) THEN
         V_DESC := V_DESC || ' VrBaseSaid=' || :NEW.VRTTBACALDEB;
      END IF;
      IF NVL(:NEW.VRTOTAIMPOS, 0) <> NVL(:OLD.VRTOTAIMPOS, 0) THEN
         V_DESC := V_DESC || ' VrImpostoRec=' || :NEW.VRTOTAIMPOS;
      END IF;
      IF NVL(:NEW.DTVENCGUIA,TO_DATE('01/01/1900', 'DD/MM/YYYY'))   <> NVL(:OLD.DTVENCGUIA,TO_DATE('01/01/1900', 'DD/MM/YYYY')) THEN
         V_DESC := V_DESC || ' DataVenc=' || :NEW.DTVENCGUIA;
      END IF;
      IF NVL(:NEW.CDRECEGUIA, '!') <> NVL(:OLD.CDRECEGUIA, '!') THEN
         V_DESC := V_DESC || ' CodReceita=' || :NEW.CDRECEGUIA;
      END IF;
      IF NVL(:NEW.DSHISTGUIA, '!') <> NVL(:OLD.DSHISTGUIA, '!') THEN
         V_DESC := V_DESC || ' Historico=' || :NEW.DSHISTGUIA;
      END IF;
      IF NVL(:NEW.VRRECEGUIA, 0) <> NVL(:OLD.VRRECEGUIA, 0) THEN
         V_DESC := V_DESC || ' VrReceita=' || :NEW.VRRECEGUIA;
      END IF;
      IF NVL(:NEW.VRJUROGUIA, 0) <> NVL(:OLD.VRJUROGUIA, 0) THEN
         V_DESC := V_DESC || ' VrJuro=' || :NEW.VRJUROGUIA;
      END IF;
      IF NVL(:NEW.VRMULTAGUIA, 0) <> NVL(:OLD.VRMULTAGUIA, 0) THEN
         V_DESC := V_DESC || ' VrMulta=' || :NEW.VRMULTAGUIA;
      END IF;
      IF NVL(:NEW.VRTOTAGUIA, 0) <> NVL(:OLD.VRTOTAGUIA, 0) THEN
         V_DESC := V_DESC || ' VrTotal=' || :NEW.VRTOTAGUIA;
      END IF;
      IF NVL(:NEW.CDFILIAL, '!') <> NVL(:OLD.CDFILIAL, '!') THEN
         V_DESC := V_DESC || ' CdFilialNf=' || :NEW.CDFILIAL;
      END IF;
      IF NVL(:NEW.NRLANCTONF, '!') <> NVL(:OLD.NRLANCTONF, '!') THEN
         V_DESC := V_DESC || ' NrLancamento=' || :NEW.NRLANCTONF;
      END IF;
   END IF;

   IF  V_TIPO <> '0' THEN
       NMUSUARIO(V_NMOPERADOR);
       WEBTUNNING(V_DSREMOTEADDR,
                  V_DSREMOTEHOST,
                  V_DSSERVERRDM,
                  V_DSSERVMETHOD,
                  V_DSREMOTEOPER);

       IF NOT V_DESC IS NULL THEN
         IF NOT V_NMOPERADOR IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,     DTOPERACAO,   NMRESPOPER,   IDTIPOOPER,  CDPESQITEM,  DSOPERACAO,
                CDFILLOGOPER, DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER,CDORESPOPER)
            VALUES
               ('MAPAAPURAC',   V_DTOPER,      V_NMOPERADOR,   V_TIPO,         V_ITPESQ,       SUBSTR(V_DESC,1,400),
                V_CDFILLOGOPER, V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
       END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_MAPAAPURAC','5.65.000'); END;
/
